package org.jboss.qe.cxf.rs.filter;

import javax.ws.rs.container.ContainerRequestContext;
import javax.ws.rs.container.ContainerRequestFilter;
import javax.ws.rs.container.ResourceInfo;
import javax.ws.rs.core.Context;
import javax.ws.rs.ext.Provider;

@Provider
public class CustomContainerRequestFilter implements ContainerRequestFilter {

	@Context
	private ResourceInfo resourceInfo;

	@Override
	public void filter(ContainerRequestContext requestContext) {
		final String resourceClass = resourceInfo.getResourceClass().getName();
		final String resourceMethod = resourceInfo.getResourceMethod().getName();

		requestContext.setProperty("resourceClass", resourceClass);
		requestContext.setProperty("resourceMethod", resourceMethod);
		requestContext.setProperty("containerRequestFilter", "containerRequestFilter");
	}
}
