package org.jboss.qe.cxf.rs.filter;

import javax.ws.rs.container.ContainerRequestContext;
import javax.ws.rs.container.ContainerResponseContext;
import javax.ws.rs.container.ContainerResponseFilter;
import javax.ws.rs.ext.Provider;

import java.io.IOException;

@Provider
public class CustomContainerResponseFilter implements ContainerResponseFilter {

	@Override
	public void filter(ContainerRequestContext requestContext, ContainerResponseContext responseContext)
			throws IOException {
		final String clientRequestFilter = requestContext.getHeaderString("clientRequestFilter");
		final String preMatchContainerRequestFilter =
				(String) requestContext.getProperty("preMatchContainerRequestFilter");
		final String resourceClass = (String) requestContext.getProperty("resourceClass");
		final String resourceMethod = (String) requestContext.getProperty("resourceMethod");
		final String containerRequestFilter = (String) requestContext.getProperty("containerRequestFilter");

		responseContext.getHeaders().add("clientRequestFilter", clientRequestFilter);
		responseContext.getHeaders().add("preMatchContainerRequestFilter", preMatchContainerRequestFilter);
		responseContext.getHeaders().add("resourceClass", resourceClass);
		responseContext.getHeaders().add("resourceMethod", resourceMethod);
		responseContext.getHeaders().add("containerRequestFilter", containerRequestFilter);
	}
}
