package org.jboss.qe.cxf.rs.filter.priority;

import javax.ws.rs.container.ContainerRequestContext;
import javax.ws.rs.container.ContainerRequestFilter;
import javax.ws.rs.container.ContainerResponseContext;
import javax.ws.rs.container.ContainerResponseFilter;

public abstract class AbstractFilter implements ContainerRequestFilter, ContainerResponseFilter {

	public static final String PRIORITYINFO = "priorityinfo";

	protected void concatHeader(int priority, ContainerRequestContext requestContext) {
		final String headerValue = requestContext.getHeaderString(PRIORITYINFO);
		requestContext.getHeaders().putSingle(PRIORITYINFO, concatValue(headerValue, priority));
	}

	protected void concatHeader(int priority, ContainerResponseContext requestContext) {
		final String headerValue = requestContext.getHeaderString(PRIORITYINFO);
		requestContext.getHeaders().putSingle(PRIORITYINFO, concatValue(headerValue, priority));
	}

	private String concatValue(String headerValue, int priority) {
		if (headerValue != null) {
			return headerValue.concat("|" + String.valueOf(priority));
		}
		return String.valueOf(priority);
	}
}
